diff --git a/gcc/ChangeLog.google-main b/gcc/ChangeLog.google-main
index 771435b..dfebff2 100644
--- a/gcc/ChangeLog.google-main
+++ b/gcc/ChangeLog.google-main
@@ -19,6 +19,8 @@
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 42718.
+
 	* doc/extend.texi (Wnonnull): Add documentation for C++.
 	* doc/invoke.texi (Wnonnull): Add documentation for C++.
 
@@ -29,6 +31,8 @@
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 39127.
+
 	* c-decl.c (warn_if_shadowing): Use the warning code corresponding
 	to the given -Wshadow- variant.
 	* common.opt (Wshadow-local): New option.
@@ -39,6 +43,8 @@
 
 2011-04-27  Silvius Rus  <silvius.rus@gmail.com>
 
+	Google ref 39984.
+
 	* doc/invoke.texi (fno-strict-enum-precision): Document.
 	* gimplify.c (gimplify_switch_expr): If
 	-fno-strict-enum-precision is given, do not consider enum
diff --git a/gcc/c-family/ChangeLog.google-main b/gcc/c-family/ChangeLog.google-main
index a6a66e0..c328b63 100644
--- a/gcc/c-family/ChangeLog.google-main
+++ b/gcc/c-family/ChangeLog.google-main
@@ -1,14 +1,20 @@
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 45339.
+
 	* c-common.c (handle_nonnull_attribute): Check whether the nonnull
 	attribute is applied to the 'this' pointer for non-static methods.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 42718.
+
 	* c.opt (Wnonnull): Enable for C++.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 39133.
+
 	* c.opt (Wreal-conversion): New flag.
 	* c-common.c (conversion_warning): Use it.
 	* c-opts.c (c_common_post_options): Initialize it.
diff --git a/gcc/cp/ChangeLog.google-main b/gcc/cp/ChangeLog.google-main
index eb35c74..607fd72 100644
--- a/gcc/cp/ChangeLog.google-main
+++ b/gcc/cp/ChangeLog.google-main
@@ -1,17 +1,23 @@
 2011-04-28  Diego Novillo  <dnovillo@google.com>
 	    Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 40484.
+
 	* call.c (conversion_null_warnings): Also handle assignments
 	when warning about NULL conversions.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 39127.
+
 	* name-lookup.c (pushdecl_maybe_friend): When emitting a
 	shadowing warning, use the code corresponding to the
 	given -Wshadow- variant.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 40484.
+
 	* cp-tree.h (LOOKUP_EXPLICIT_TMPL_ARGS): Define.
 	* call.c (build_new_function_call): Set it for TEMPLATE_ID_EXPRs.
 	(build_over_call): Use it to determine whether to emit a NULL
diff --git a/gcc/testsuite/ChangeLog.google-main b/gcc/testsuite/ChangeLog.google-main
index 3a76097..1518b7b 100644
--- a/gcc/testsuite/ChangeLog.google-main
+++ b/gcc/testsuite/ChangeLog.google-main
@@ -1,3 +1,10 @@
+2011-04-29  Diego Novillo  <dnovillo@google.com>
+
+	Google ref 40484.
+
+	* g++.old-deja/g++.other/null3.C: Expect warning about
+	converting boolean to a pointer.
+
 2011-04-28  Diego Novillo  <dnovillo@google.com>
 
 	* g++.dg/other/no-strict-enum-precision-1.C: Re-indent using GNU style.
@@ -15,6 +22,8 @@
 
 2011-04-28  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 40484.
+
 	* g++.dg/warn/Wconversion-null-2.C: Do not expect a NULL
 	  warning in implicitly instantiated templates.
 
@@ -54,19 +63,27 @@
 	
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 45339.
+
 	* g++.dg/warn/nonnull2.C: New.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 42718.
+
 	* g++.dg/warn/Wnonnull-1.C: New.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 39133.
+
 	* g++.dg/warn/Wreal-conversion-1.C: New.
 	* gcc.dg/Wreal-conversion-1.c: New.
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 39127.
+
 	* g++.dg/warn/Wshadow-compatible-local-1.C: New.
 	* g++.dg/warn/Wshadow-local-1.C: New.
 	* g++.dg/warn/Wshadow-local-2.C: New.
@@ -77,11 +94,15 @@
 
 2011-04-27  Le-Chun Wu  <lcwu@google.com>
 
+	Google ref 40484.
+
 	* g++.dg/warn/Wnull-conversion-1.C: New.
 	* g++.dg/warn/Wnull-conversion-2.C: New.
 
 2011-04-27  Silvius Rus  <silvius.rus@gmail.com>
 
+	Google ref 39984.
+
 	* g++.dg/other/no-strict-enum-precision-1.C: New.
 	* g++.dg/other/no-strict-enum-precision-2.C: New.
 	* g++.dg/other/no-strict-enum-precision-3.C: New.